//Soutezici s cislem 7
//Rodice jsou vlevo - potomci jdou doprava
//Kazdy potomek je spojen se svymi rodici carami
//Linux je nejlepsi, at zije Linux

// mcr07.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
using namespace std;

#define MAX_LOADSTRING 100

enum POHLAVI
{
	M = 0,Z = 1
};

class Osoba //trida zapouzdrujici osobu
{
public:
	string id,jmeno,prijmeni,otec,matka;
	POHLAVI pohlavi;
	int narozeni,umrti;
	int x,y;
	vector<Osoba*> deti;
	Osoba *potec,*pmatka;
	Osoba(string nid, string njmeno, string nprijmeni, string notec,
		string nmatka,
		POHLAVI npohlavi, int nnarozeni, int numrti) : id(nid),
		jmeno(njmeno), prijmeni(nprijmeni), otec(notec), matka(nmatka),
		pohlavi(npohlavi), narozeni(nnarozeni), umrti(numrti)
	{ };
};

vector<Osoba*> koreny;
vector<Osoba*> ruseni;
vector<Osoba*> kresleni;
Osoba* oznacen = 0;

Osoba* Najdi(string nid,Osoba *zdroj)
 //rekurzivne hledajici funkce
{
	if (nid=="") return 0;
	Osoba* nalezeno = 0;
	if (zdroj->id == nid) return zdroj;
	if (zdroj->deti.size() == 0) return 0;
	for (int i=0;i<zdroj->deti.size();i++)
	{
		nalezeno = Najdi(nid,zdroj->deti[i]);
		if (nalezeno) break;
	}
	return nalezeno;
}

Osoba* Prohledej(string nid)
 //hleda osobu podle id
{
	if (nid=="") return 0;
	Osoba* nalezeno = 0;
	for (int i=0;i<koreny.size();i++)
	{
		nalezeno = Najdi(nid,koreny[i]);
		if (nalezeno) break;
	}
	return nalezeno;
}

bool Pridej(string nid, string njmeno, string nprijmeni, string notec, 
			string nmatka, POHLAVI npohlavi, int nnarozeni, int numrti)
 //pridani osoby do rodokmenu
{
	Osoba* nova = new Osoba(nid,njmeno,nprijmeni,notec,nmatka,
			npohlavi,nnarozeni,numrti);
	if (nmatka=="" && notec=="")
	{
		koreny.push_back(nova);
		return 1;
	}
	Osoba *matka=0,*otec=0;
	matka = Prohledej(nmatka);
	otec = Prohledej(notec);
	if (!matka && !otec)
	{
		koreny.push_back(nova);
		return 1;
	}
	if (matka) matka->deti.push_back(nova);
	if (otec) otec->deti.push_back(nova);
	return 1;
}

void Smazat(Osoba* zdroj)
 //vymaz osoby z rodokmenu
{
	int i;
	for (i=0;i<zdroj->deti.size();i++)
	{
		if (zdroj->deti[i]->pmatka == zdroj)
		{
			zdroj->deti[i]->pmatka = 0;
			zdroj->deti[i]->matka = "";
		}
		if (zdroj->deti[i]->potec == zdroj)
		{
			zdroj->deti[i]->potec = 0;
			zdroj->deti[i]->otec = "";
		}
		if (zdroj->deti[i]->potec==0 && zdroj->deti[i]->pmatka==0)
		{
			koreny.push_back(zdroj->deti[i]);
		}
	}
	if (zdroj->pmatka)
	{
		vector<Osoba*>::iterator iter = zdroj->pmatka->deti.begin();
		do {
			if (*iter == zdroj)
			{
				zdroj->pmatka->deti.erase(iter);
				break;
			}
		} while(iter++);
	}
	if (zdroj->potec)
	{
		vector<Osoba*>::iterator iter = zdroj->potec->deti.begin();
		do {
			if (*iter == zdroj)
			{
				zdroj->potec->deti.erase(iter);
				break;
			}
		} while(iter++);
	}
	if (zdroj->pmatka==0 && zdroj->potec==0)
	{
		vector<Osoba*>::iterator iter = koreny.begin();
		do {
			if (*iter == zdroj)
			{
				koreny.erase(iter);
				break;
			}
		} while(iter++);
	}
	delete zdroj;
}

void SaveTo(string filename)
 //ulozeni do souboru
{
	if (filename == "") return;
	ofstream out(filename.c_str());
	out<<"<rodokmen>\n";
	for (int i=0;i<kresleni.size();i++)
	{
		out<<"<osoba>\n";
		out<<"<id>"<<kresleni[i]->id<<"</id>\n";
		if (kresleni[i]->jmeno != "")
			out<<"<jmeno>"<<kresleni[i]->jmeno<<"</jmeno>\n";
		else
			out<<"<jmeno/>\n";
		if (kresleni[i]->prijmeni != "")
			out<<"<prijmeni>"<<kresleni[i]->prijmeni<<"</prijmeni>\n";
		else
			out<<"<prijmeni/>\n";
		if (kresleni[i]->pohlavi)
			out<<"<pohlavi>"<<"Z"<<"</pohlavi>\n";
		else
			out<<"<pohlavi>"<<"M"<<"</pohlavi>\n";
		if (kresleni[i]->narozeni != 0)
			out<<"<narozeni>"<<kresleni[i]->narozeni<<"</narozeni>\n";
		else
			out<<"<narozeni/>\n";
		if (kresleni[i]->umrti != 0)
			out<<"<umrti>"<<kresleni[i]->umrti<<"</umrti>\n";
		else
			out<<"<umrti/>\n";
		if (kresleni[i]->matka != "")
			out<<"<matka>"<<kresleni[i]->matka<<"</matka>\n";
		else
			out<<"<matka/>\n";
		if (kresleni[i]->otec != "")
			out<<"<otec>"<<kresleni[i]->otec<<"</otec>\n";
		else
			out<<"<otec/>\n";
		out<<"</osoba>\n";
	}
	out<<"</rodokmen>\n";
	MessageBox(NULL,"Hotovo - Ulozeno","Dokoncena operace",MB_OK);
}

void Zrus(Osoba* zdroj)
 //funkce rekurzivne rusici objekty
{
	int i;
	for (i=0;i<ruseni.size();i++)
		if (ruseni[i] == zdroj) return;
	ruseni.push_back(zdroj);
	for (i=0;i<zdroj->deti.size();i++)
	{
		Zrus(zdroj->deti[i]);
	}
	delete zdroj;
}

void ZrusVse() //ruseni objektu
{
	for (int i=0;i<koreny.size();i++)
	{
		Zrus(koreny[i]);
	}
	koreny.clear();
}

void Vylistuj(Osoba* zdroj) //viz Vylistuj()
{
	string msg = "Jmeno:" + zdroj->id + " Otec:" + zdroj->otec +
		" Matka:" + zdroj->matka;
	MessageBox(NULL,msg.c_str(),"",MB_OK);
	MessageBox(NULL,"Deti:","",MB_OK);
	for (int i=0;i<zdroj->deti.size();i++)
	{
		Vylistuj(zdroj->deti[i]);
	}
	MessageBox(NULL,"Konec deti","",MB_OK);
}

void Vylistuj() //funkce pro potreby ladeni
{
	for (int i=0;i<koreny.size();i++)
	{
		Vylistuj(koreny[i]);
	}
}

void DelejPribuzne(Osoba* zdroj) //viz DelejPribuzne()
{
	zdroj->pmatka = Prohledej(zdroj->matka);
	zdroj->potec = Prohledej(zdroj->otec);
	for (int i=0;i<zdroj->deti.size();i++)
	{
		DelejPribuzne(zdroj->deti[i]);
	}
}

void DelejPribuzne() //hleda ukazatele na objekty rodicu
{
	for (int i=0;i<koreny.size();i++)
	{
		DelejPribuzne(koreny[i]);
	}
}

int Vykresli(HDC hdc, RECT rt, Osoba* zdroj,int x,int y)
 //rekurzivne vykreslujici funkce
{
	int i;
	for (i=0;i<kresleni.size();i++)
		if (kresleni[i] == zdroj) return y;
	kresleni.push_back(zdroj);
	string msg = zdroj->id + ": \"" + zdroj->jmeno + " " + zdroj->prijmeni + "\" Rodice:" + zdroj->otec + ", " + zdroj->matka;
	if (oznacen == zdroj) msg += " <Oznacen>";
	TextOut(hdc,x,y,msg.c_str(),strlen(msg.c_str()));
	zdroj->x = x;
	zdroj->y = y;
	y+=20;
	for (i=0;i<zdroj->deti.size();i++)
	{
		y = Vykresli(hdc,rt,zdroj->deti[i],x+10,y);
	}
	return y;
}

void VykresliCary(HDC hdc, RECT rt, Osoba* zdroj)
 //vykresleni car od deti k rodicum
{
	int i;
	if (zdroj->potec)
	{
		MoveToEx(hdc,zdroj->x,zdroj->y+6,NULL);
		LineTo(hdc,zdroj->potec->x,zdroj->potec->y+6);
	}
	if (zdroj->pmatka)
	{
		MoveToEx(hdc,zdroj->x,zdroj->y+6,NULL);
		LineTo(hdc,zdroj->pmatka->x,zdroj->pmatka->y+6);
	}
	for (i=0;i<zdroj->deti.size();i++)
	{
		VykresliCary(hdc,rt,zdroj->deti[i]);
	}
}

void Vykresli(HDC hdc, RECT rt) //vykresleni na obrazovku
{
	kresleni.clear();
	DelejPribuzne();
	int y = 0,i;
	for (i=0;i<koreny.size();i++)
	{
		y = Vykresli(hdc,rt,koreny[i],10,y);
	}
	for (i=0;i<kresleni.size();i++)
	{
		VykresliCary(hdc,rt,kresleni[i]);
	}
}

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text
HWND hW;

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	Add(HWND, UINT, WPARAM, LPARAM);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_MCR07, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_MCR07);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_MCR07);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_MCR07;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   hW = hWnd;

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

string GetFileName(HWND hwnd)
 //zobrazi dialog pro zadani jmena souboru pro ulozeni
{
	OPENFILENAME ofn;       // common dialog box structure
	char szFile[260] = "";       // buffer for file name
	// Initialize OPENFILENAME
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hwnd;
	ofn.lpstrFile = szFile;
	ofn.nMaxFile = sizeof(szFile);
	ofn.lpstrFilter = "All\0*.*\0Text\0*.TXT\0";
	ofn.nFilterIndex = 1;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST;

	// Display the Open dialog box. 

	if (GetSaveFileName(&ofn)==TRUE)
		return string(szFile);
	return string("");
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_ADD:
				   DialogBox(hInst, (LPCTSTR)IDD_ADDDLG, hWnd, (DLGPROC)Add);
				   break;
				case IDM_DEL:
					if (!oznacen) break;
					Smazat(oznacen);
					InvalidateRect(hWnd,NULL,TRUE);
					break;
				case IDM_SAVE:
					SaveTo(GetFileName(hWnd));
					break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_LBUTTONDOWN: //oznaceni polozky
			int y;
			y = HIWORD(lParam);
			if ((y>(kresleni.size()*20)) || kresleni.size()==0)
				oznacen = 0;
			else
				oznacen = kresleni[(int)y/20];
			InvalidateRect(hWnd,NULL,TRUE);
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
			RECT rt;
			GetClientRect(hWnd, &rt);
			Vykresli(hdc,rt);
			//DrawText(hdc, szHello, strlen(szHello), &rt, DT_CENTER);
			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			ZrusVse();
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

LRESULT CALLBACK Add(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
 //procedura okna pro pridani osoby
{
	int i,im=1,iz=1;string tmp,niotec="",nimatka="";
	switch (message)
	{
		case WM_INITDIALOG:
			HWND list,listm,listz;
			list = GetDlgItem(hDlg,IDC_POHLAVI);
			listm = GetDlgItem(hDlg,IDC_OTEC);
			listz = GetDlgItem(hDlg,IDC_MATKA);
			SendMessage(list,CB_ADDSTRING,0,(LPARAM)"M");
			SendMessage(list,CB_ADDSTRING,0,(LPARAM)"Z");
			SendMessage(list,CB_SETCURSEL,0,0);
			SendMessage(listm,CB_ADDSTRING,0,(LPARAM)"<nema otce>");
			SendMessage(listz,CB_ADDSTRING,0,(LPARAM)"<nema matku>");
			for (i=0;i<kresleni.size();i++)
			{
				tmp = kresleni[i]->jmeno + " " + kresleni[i]->prijmeni;
				if (kresleni[i]->pohlavi == M)
				{
					SendMessage(listm,CB_ADDSTRING,0,(LPARAM)tmp.c_str());
					SendMessage(listm,CB_SETITEMDATA,im++,(LPARAM)kresleni[i]);
				}
				if (kresleni[i]->pohlavi == Z)
				{
					SendMessage(listz,CB_ADDSTRING,0,(LPARAM)tmp.c_str());
					SendMessage(listz,CB_SETITEMDATA,iz++,(LPARAM)kresleni[i]);
				}
			}
			SendMessage(listm,CB_SETCURSEL,0,0);
			SendMessage(listz,CB_SETCURSEL,0,0);
			return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK)
			{
				list = GetDlgItem(hDlg,IDC_POHLAVI);
				listm = GetDlgItem(hDlg,IDC_OTEC);
				listz = GetDlgItem(hDlg,IDC_MATKA);
				POHLAVI npohlavi;
				npohlavi = (POHLAVI)SendMessage(list,CB_GETCURSEL,0,0);
				char nid[11],njmeno[33],nprijmeni[33];
				int nnarozeni,numrti;
				Osoba *nmatka,*notec;int matka,otec;
				matka = SendMessage(listz,CB_GETCURSEL,0,0);
				if (matka)
				{
					nmatka = (Osoba*)SendMessage(listz,CB_GETITEMDATA,matka,0);
					nimatka = nmatka->id;
				}
				else nmatka = 0;
				otec = SendMessage(listm,CB_GETCURSEL,0,0);
				if (otec)
				{
					notec = (Osoba*)SendMessage(listm,CB_GETITEMDATA,otec,0);
					niotec = notec->id;
				}
				else notec = 0;
				GetDlgItemText(hDlg,IDC_ID,nid,10);
				GetDlgItemText(hDlg,IDC_JMENO,njmeno,32);
				GetDlgItemText(hDlg,IDC_PRIJMENI,nprijmeni,32);
				nnarozeni = GetDlgItemInt(hDlg,IDC_NAROZENI,NULL,0);
				numrti = GetDlgItemInt(hDlg,IDC_UMRTI,NULL,0);
				Pridej(nid,njmeno,nprijmeni,niotec,nimatka,npohlavi,nnarozeni,numrti);
				InvalidateRect(hW,NULL,1);
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			if (LOWORD(wParam) == IDCANCEL)
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
